from bottle import request, get, post, static_file, route, run
import ibm_db
from itoolkit import *
from itoolkit.lib.ilibcall import *     #for local jobs 
 
port_number=9090
host_location='10.2.0.1'
file_name='sample.html'
db_name = '*LOCAL'
username = 'PYTHON'
password = 'python'
 
 
@route('/sample')
def sample():
    return static_file(file_name, root='/home/NB/python') 
 
 
@route('/query', method='POST')
def query_ibm_db():
    html_result = ""
    # html table styling
    html_result += "<style>table, th, td {border: 1px solid black;border-collapse: collapse;}"
    html_result += "th, td {padding: 5px;text-align: left;width: 200px;}tr:nth-child(even) {background-color: #f3f3f3;}"
    html_result += "tr:nth-child(odd) {background-color:#fff;}th {background-color: #008ABF;color: white}</style>"
   
    conn = ibm_db.connect(db_name, username, password)
   
    if conn:
      statement = request.forms.get('sql')
      result_set = ibm_db.exec_immediate(conn, statement)
 
      num_columns = ibm_db.num_fields (result_set)
     
      html_result += "<table><tr>"
      # create table headers from column names
      for num in range(0, num_columns):
        html_result += "<th>" + ibm_db.field_name(result_set, num) + "</th>"
       
      html_result += "</tr>"
      # insert results into table
      while (ibm_db.fetch_row(result_set)):
        html_result += "<tr>" 
        for num in range(0, num_columns):
          result = ibm_db.result(result_set, num)
          html_result += "<td>" + str(result) + "</td>"
        html_result += "</tr>"
       
      html_result += "</table>" 
      ibm_db.close(conn)
      return html_result
       
    else:
      return "<p>Connection Failed.</p>"
 
 
@route('/cmd', method='POST')
def cmd_toolkit():
   
    html_result = "<pre><p>"
   
    cl_statement = request.forms.get('cl')
   
    itool = iToolKit()
   
    # xmlservice
    itransport = iLibCall()
 
    itool.add(iCmd5250(cl_statement,cl_statement))
    itool.call(itransport)
   
    # results from list
    output_list = itool.list_out()
    for output_outer in output_list:
        for output_inner in output_outer:
            html_result += output_inner
       
    # results from dict
    """
    output_dict = itool.dict_out(cl_statement)
    if 'error' in output_dict:
        html_result += (output_dict['error'])
        exit()
    else:
        html_result += (output_dict[cl_statement])   
    """
 
    html_result += "</p></pre>"
 
    return html_result 
 
run(host=host_location, port=port_number, debug=True)